From 1d433f600e6eecfe685650a06e58d1a8edae9b5d Mon Sep 17 00:00:00 2001
From: Levente Polyak <anthraxx@archlinux.org>
Date: Sat, 27 Apr 2024 01:50:57 +0200
Subject: feat(db): confirm list of all packages that will be removed

Sometimes it isn't obvious which set of packages are removed from a
split package when the pkgbase matches also a subset of a pkgbase. This
can happen for example with bootstrapping packages, when the intention
is to just remove a partial part of the bootstrap pkgbase.

To make the intention more explicit, list all to be removed packages and
await for confirmation.

Component: pkgctl db remove
Signed-off-by: Levente Polyak <anthraxx@archlinux.org>
---
 src/lib/db/remove.sh | 57 +++++++++++++++++++++++++++++++++++++++++++++++++++-
 1 file changed, 56 insertions(+), 1 deletion(-)

(limited to 'src/lib/db/remove.sh')

diff --git a/src/lib/db/remove.sh b/src/lib/db/remove.sh
index 018b793..6ca091d 100644
--- a/src/lib/db/remove.sh
+++ b/src/lib/db/remove.sh
@@ -8,6 +8,10 @@ DEVTOOLS_INCLUDE_DB_REMOVE_SH=1
 _DEVTOOLS_LIBRARY_DIR=${_DEVTOOLS_LIBRARY_DIR:-@pkgdatadir@}
 # shellcheck source=src/lib/common.sh
 source "${_DEVTOOLS_LIBRARY_DIR}"/lib/common.sh
+# shellcheck source=src/lib/util/pacman.sh
+source "${_DEVTOOLS_LIBRARY_DIR}"/lib/util/pacman.sh
+# shellcheck source=src/lib/util/term.sh
+source "${_DEVTOOLS_LIBRARY_DIR}"/lib/util/term.sh
 
 set -e
 
@@ -29,6 +33,7 @@ pkgctl_db_remove_usage() {
 		    -a, --arch    Remove only one specific architecture (disables auto-detection)
 		    --partial     Remove only partial pkgnames from a split package. This leaves
 		                  debug packages behind and pkgbase entries in the state repo.
+		    --noconfirm   Bypass any confirmation messages, should only be used with caution
 		    -h, --help    Show this help text
 
 		EXAMPLES
@@ -40,8 +45,12 @@ _EOF_
 pkgctl_db_remove() {
 	local REPO=""
 	local PKGBASES=()
+	local pkgnames=()
 	local partial=0
+	local confirm=1
 	local dbscripts_options=()
+	local lookup_repo=multilib
+	local pkgname
 
 	# option checking
 	while (( $# )); do
@@ -60,6 +69,10 @@ pkgctl_db_remove() {
 				dbscripts_options+=(--arch "$2")
 				shift 2
 				;;
+			--noconfirm)
+				confirm=0
+				shift
+				;;
 			-*)
 				die "invalid argument: %s" "$1"
 				;;
@@ -77,6 +90,40 @@ pkgctl_db_remove() {
 	REPO=$1
 	shift
 	PKGBASES+=("$@")
+	pkgnames=("${PKGBASES[@]}")
+
+	# update pacman cache to query all pkgnames
+	if (( ! partial )); then
+		case ${REPO} in
+			*-unstable)
+				update_pacman_repo_cache unstable
+				;;
+			*-staging)
+				update_pacman_repo_cache multilib-staging
+				;;
+			*-testing)
+				update_pacman_repo_cache multilib-testing
+				;;
+			*)
+				update_pacman_repo_cache multilib
+				;;
+		esac
+
+		# fetch the pkgnames of all pkgbase as present in the repo
+		mapfile -t pkgnames < <(get_pkgnames_from_repo_pkgbase "${REPO}" "${PKGBASES[@]}")
+		echo
+
+		if (( ! ${#pkgnames[@]} )); then
+			error "Packages not found in %s" "${REPO}"
+			exit 1
+		fi
+	fi
+
+	# print list of packages
+	printf "%sRemoving packages from %s:%s\n" "${RED}" "${REPO}" "${ALL_OFF}"
+	for pkgname in "${pkgnames[@]}"; do
+		printf "• %s\n" "${pkgname}"
+	done
 
 	# print explenation about partial removal
 	if (( partial )); then
@@ -85,7 +132,15 @@ pkgctl_db_remove() {
 		msg_warn "${YELLOW}This leaves debug packages and pkgbase entries in the state repo!${ALL_OFF}"
 	fi
 
-	# shellcheck disable=SC2029
+	# ask for confirmation
+	if (( confirm )); then
+		echo
+		if ! prompt "${GREEN}${BOLD}?${ALL_OFF} Are you sure this is correct?"; then
+			exit 1
+		fi
+	fi
+
 	echo
+	# shellcheck disable=SC2029
 	ssh "${PACKAGING_REPO_RELEASE_HOST}" db-remove "${dbscripts_options[@]}" "${REPO}" "${PKGBASES[@]}"
 }
-- 
cgit v1.2.3-70-g09d2